"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactGoogleMaps = require("react-google-maps");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var defaultProps = {
  options: {
    fillColor: '#ee430e',
    strokeColor: '#ee430e',
    strokeWeight: 1,
    fillOpacity: .3,
    strokeOpacity: .5
  }
};

var MapRectangle =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(MapRectangle, _Component);

  function MapRectangle() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = MapRectangle.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        defaultBounds = _this$props.defaultBounds,
        defaultDraggable = _this$props.defaultDraggable,
        defaultEditable = _this$props.defaultEditable,
        defaultOptions = _this$props.defaultOptions,
        defaultVisible = _this$props.defaultVisible,
        bounds = _this$props.bounds,
        draggable = _this$props.draggable,
        editable = _this$props.editable,
        options = _this$props.options,
        visible = _this$props.visible,
        _onDblClick = _this$props.onDblClick,
        _onDragEnd = _this$props.onDragEnd,
        _onDragStart = _this$props.onDragStart,
        _onMouseDown = _this$props.onMouseDown,
        _onMouseMove = _this$props.onMouseMove,
        _onMouseOut = _this$props.onMouseOut,
        _onMouseOver = _this$props.onMouseOver,
        _onMouseUp = _this$props.onMouseUp,
        _onRightClick = _this$props.onRightClick,
        _onBoundsChanged = _this$props.onBoundsChanged,
        _onClick = _this$props.onClick,
        _onDrag = _this$props.onDrag,
        removeMarker = _this$props.removeMarker;
    return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_reactGoogleMaps.Rectangle, {
      ref: function ref(rectangle) {
        return _this.rectangle = rectangle;
      },
      defaultBounds: defaultBounds,
      defaultDraggable: defaultDraggable,
      defaultEditable: defaultEditable,
      defaultOptions: defaultOptions,
      defaultVisible: defaultVisible,
      bounds: bounds,
      visible: visible,
      options: options,
      draggable: draggable,
      editable: editable,
      onDragStart: function onDragStart() {
        return _this.rectangle && _onDragStart && _onDragStart(_this.rectangle.getBounds());
      },
      onDragEnd: function onDragEnd() {
        return _this.rectangle && _onDragEnd && _onDragEnd(_this.rectangle.getBounds());
      },
      onDrag: function onDrag() {
        return _this.rectangle && _onDrag && _onDrag(_this.rectangle.getBounds());
      },
      onBoundsChanged: function onBoundsChanged() {
        return _this.rectangle && _onBoundsChanged && _onBoundsChanged(_this.rectangle.getBounds());
      },
      onDblClick: function onDblClick() {
        return _onDblClick && _onDblClick();
      },
      onClick: function onClick() {
        return _onClick && _onClick();
      },
      onMouseDown: function onMouseDown() {
        return _onMouseDown && _onMouseDown();
      },
      onMouseMove: function onMouseMove() {
        return _onMouseMove && _onMouseMove();
      },
      onMouseOut: function onMouseOut() {
        return _onMouseOut && _onMouseOut();
      },
      onMouseOver: function onMouseOver() {
        return _onMouseOver && _onMouseOver();
      },
      onMouseUp: function onMouseUp() {
        return _onMouseUp && _onMouseUp();
      },
      onRightClick: function onRightClick() {
        return _onRightClick && _onRightClick();
      }
    }), !removeMarker && _react.default.createElement(_reactGoogleMaps.Marker, {
      position: bounds,
      visible: false
    }));
  };

  return MapRectangle;
}(_react.Component);

MapRectangle.defaultProps = defaultProps;
var _default = MapRectangle;
exports.default = _default;