"use strict";

exports.__esModule = true;
exports.PrivateRoute = void 0;

var _reactRouterDom = require("react-router-dom");

var _reactRedux = require("react-redux");

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var PrivateRoute =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(PrivateRoute, _Component);

  function PrivateRoute() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = PrivateRoute.prototype;

  _proto.handleUnauthorizedAccess = function handleUnauthorizedAccess() {
    console.log(window.location);
    var href = window.location.href;
    return _react.default.createElement(_reactRouterDom.Route, {
      render: function render() {
        return window.location = "http://auth.localcinnecta.com/signin?continue=" + href;
      }
    });
  };

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        Component = _this$props.component,
        render = _this$props.render,
        authenticated = _this$props.authenticated,
        loading = _this$props.loading,
        location = _this$props.location,
        rest = _objectWithoutPropertiesLoose(_this$props, ["component", "render", "authenticated", "loading", "location"]);

    if (loading) {
      return _react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
        component: Loading
      }));
    }

    var renderMethod = render;

    if (render && !authenticated) {
      renderMethod = function renderMethod() {
        return _this.handleUnauthorizedAccess(location);
      };
    }

    return _react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
      render: render ? renderMethod : function (props) {
        return authenticated ? _react.default.createElement(Component, props) : _this.handleUnauthorizedAccess(location);
      }
    }));
  };

  return PrivateRoute;
}(_react.Component);

var Loading = function Loading() {
  return _react.default.createElement("div", null, "Autenticando...");
};

var mapStateToProps = function mapStateToProps(state) {
  var _state$auth = state.auth,
      authenticated = _state$auth.authenticated,
      loading = _state$auth.loading;
  return {
    authenticated: authenticated,
    loading: loading
  };
};

var ConnectedPrivateRoute = (0, _reactRedux.connect)(mapStateToProps)(PrivateRoute);
exports.PrivateRoute = ConnectedPrivateRoute;